package cn.iocoder.yudao.module.supplier.service.product;

import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.CoreProductPageReqVO;
import cn.iocoder.yudao.module.supplier.controller.admin.product.vo.CoreProductSaveReqVO;
import cn.iocoder.yudao.module.supplier.dal.dataobject.product.CoreProductDO;
import cn.iocoder.yudao.module.supplier.dal.mysql.product.CoreProductMapper;
import cn.iocoder.yudao.module.supplier.enums.ErrorCodeConstant;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;


import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 供应商核心产品 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class CoreProductServiceImpl implements CoreProductService {

    @Resource
    private CoreProductMapper coreProductMapper;

    @Override
    public Long createCoreProduct(CoreProductSaveReqVO createReqVO) {
        // 插入
        CoreProductDO coreProduct = BeanUtils.toBean(createReqVO, CoreProductDO.class);
        coreProductMapper.insert(coreProduct);
        // 返回
        return coreProduct.getId();
    }

    @Override
    public void updateCoreProduct(CoreProductSaveReqVO updateReqVO) {
        // 校验存在
        validateCoreProductExists(updateReqVO.getId());
        // 更新
        CoreProductDO updateObj = BeanUtils.toBean(updateReqVO, CoreProductDO.class);
        coreProductMapper.updateById(updateObj);
    }

    @Override
    public void deleteCoreProduct(Long id) {
        // 校验存在
        validateCoreProductExists(id);
        // 删除
        coreProductMapper.deleteById(id);
    }

    private void validateCoreProductExists(Long id) {
        if (coreProductMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstant.NOT_EXISTS);
        }
    }

    @Override
    public CoreProductDO getCoreProduct(Long id) {
        return coreProductMapper.selectById(id);
    }

    @Override
    public PageResult<CoreProductDO> getCoreProductPage(CoreProductPageReqVO pageReqVO) {
        return coreProductMapper.selectPage(pageReqVO);
    }

    @Override
    public List<CoreProductDO> getAllCoreProduct() {
        return coreProductMapper.selectList();
    }


}
